# DarAuthority: dag

# DarSoapbox: 0
# DarArchs: i686 i586 i386 athlon

%define _libexecdir /lib/modules

### FIXME: Arch athlon doesn't have _initrddir defined.
%define _initrddir %{_sysconfdir}/rc.d/init.d

%{!?kernel:%define kernel %(rpm -q kernel-source --qf '%{RPMTAG_VERSION}-%{RPMTAG_RELEASE}' | tail -1)}

%define kversion %(echo "%{kernel}" | sed -e 's|-.*||')
%define krelease %(echo "%{kernel}" | sed -e 's|.*-||')

%define moduledir /kernel/drivers/char/%{name}
%define modules_orig drivers/lirc_dev/lirc_dev.o drivers/lirc_i2c/lirc_i2c.o
%define modules lirc_dev.o lirc_i2c.o

%define rrelease 4

Summary: Decode and send infra-red signals of remote controls.
Name: lirc
Version: 0.6.6
Release: %{rrelease}.dag
License: GPL
Group: System Environment/Libraries
URL: http://www.lirc.org/

Packager: Dag Wieers <dag@wieers.com>
Vendor: Dag Apt Repository, http://dag.wieers.com/apt/

Source: http://prdownloads.sourceforge.net/lirc/%{name}-%{version}.tar.gz
BuildRoot: %{_tmppath}/root-%{name}-%{version}
Prefix: %{_prefix}

BuildRequires: kernel-source

%description
LIRC is a package that allows you to decode and send infra-red signals of
many (but not all) commonly used remote controls.

%package devel
Summary: Header files, libraries and development documentation for %{name}.
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs using %{name},
you will need to install %{name}-devel.

%package -n kernel-module-lirc
Release: %{rrelease}_%{kversion}_%{krelease}.dag
Summary: LIRC kernel modules.
Group: System Environment/Kernel

Requires: kernel = %{kversion}-%{krelease}, %{name} = %{version}

%description -n kernel-module-lirc
LIRC kernel modules.

These drivers are built for kernel %{kversion}-%{krelease}.
They might work with newer/older kernels.

%package -n kernel-smp-module-lirc
Release: %{rrelease}_%{kversion}_%{krelease}.dag
Summary: LIRC kernel modules.
Group: System Environment/Kernel

Requires: kernel-smp = %{kversion}-%{krelease}, %{name} = %{version}

%description -n kernel-smp-module-lirc
LIRC kernel modules for SMP.

These drivers are built for kernel %{kversion}-%{krelease}smp.
They might work with newer/older kernels.

%prep
%setup

%{__cat} <<'EOF' >lircd.sysv
#!/bin/sh
#
# Startup script for the Linux Infrared Remote Control.
#
# Written by Dag Wieers <dag@wieers.com>.
#
# chkconfig: - 90 10
# description: Enables infrared controls through LIRC.
#
# processname: lircd
# config: %{_sysconfdir}/lircd.conf
# pidfile: %{_localstatedir}/run/lircd

# Source function library.
source %{_initrddir}/functions

[ -x %{_sbindir}/lircd ] || exit 1
[ -r %{_sysconfdir}/lircd.conf ]  || exit 1

RETVAL=0
prog="lircd"
desc="IR Remote Control"

start() {
	echo -n $"Starting $desc ($prog): "
	daemon $prog
	RETVAL=$?
	echo
	[ $RETVAL -eq 0 ] && touch %{_localstatedir}/lock/subsys/$prog
	return $RETVAL
}

stop() {
        echo -n $"Shutting down $desc ($prog): "
        killproc $prog
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && rm -f %{_localstatedir}/lock/subsys/$prog
        return $RETVAL
}

restart() {
	stop
	start
}

case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  restart)
	restart
	;;
  condrestart)
	[ -e %{_localstatedir}/lock/subsys/$prog ] && restart
	RETVAL=$?
	;;
  status)
	status $prog
	RETVAL=$?
	;;
  *)
	echo $"Usage: $0 {start|stop|restart|condrestart|status}"
	RETVAL=1
esac

exit $RETVAL
EOF

%{__cat} <<'EOF' >lircmd.sysv
#!/bin/sh
#
# Startup script for the Linux Infrared Remote Control Mouse.
#
# chkconfig: - 90 10
# description: Enables infrared mouse controls through LIRC.
#
# processname: lircmd
# config: %{_sysconfdir}/lircmd.conf
# pidfile: %{_localstatedir}/run/lircmd

# Source function library.
source %{_initrddir}/functions

[ -x %{_sbindir}/lircmd ] || exit 1
[ -r %{_sysconfdir}/lircmd.conf ] || exit 1

RETVAL=0
prog="lircmd"
desc="IR remote control mouse"

start() {
	echo -n $"Starting $desc ($prog): "
	daemon $prog
	RETVAL=$?
	echo
	[ $RETVAL -eq 0 ] && touch %{_localstatedir}/lock/subsys/$prog
	return $RETVAL
}

stop() {
        echo -n $"Shutting down $desc ($prog): "
        killproc $prog
        RETVAL=$?
        echo
        [ $RETVAL -eq 0 ] && rm -f %{_localstatedir}/lock/subsys/$prog
        return $RETVAL
}

restart() {
	stop
	start
}

case "$1" in
  start)
	start
	;;
  stop)
	stop
	;;
  restart)
	restart
	;;
  condrestart)
	[ -e %{_localstatedir}/lock/subsys/$prog ] && restart
	RETVAL=$?
	;;
  status)
	status $prog
	RETVAL=$?
	;;
  *)
	echo $"Usage: $0 {start|stop|restart|condrestart|status}"
	RETVAL=1
esac

exit $RETVAL
EOF

%build
### Prepare UP kernel.
cd %{_usrsrc}/linux-%{kversion}-%{krelease}
%{__make} distclean
%{__cp} -f configs/kernel-%{kversion}-%{_target_cpu}.config .config
%{__perl} -pi -e 's#%{krelease}custom#%{krelease}#' Makefile
%{__make} symlinks oldconfig
%{__make} dep
cd -

### Make UP module.
%configure \
	--with-driver="hauppauge" \
	--with-moduledir="%{buildroot}%{_libexecdir}/%{kversion}-%{krelease}%{moduledir}" \
	--with-kerneldir="%{_libexecdir}/%{kversion}-%{krelease}/build" \
	--with-devdir="/dev" \
	--with-x \
	--with-syslog="LOG_USER" \
	--with-gnu-ld
%{__make} %{?_smp_mflags}

%{__install} -d -m0755 %{name}-up/
%{__mv} -f %{modules_orig} %{name}-up/

### Prepare SMP kernel.
cd %{_usrsrc}/linux-%{kversion}-%{krelease}
%{__make} distclean
%{__cp} -f configs/kernel-%{kversion}-%{_target_cpu}-smp.config .config
%{__make} symlinks oldconfig
%{__make} dep
cd -

### Make SMP module.
%configure \
	--with-driver="hauppauge" \
	--with-moduledir="%{buildroot}%{_libexecdir}/%{kversion}-%{krelease}smp%{moduledir}/" \
	--with-kerneldir="%{_libexecdir}/%{kversion}-%{krelease}/build" \
	--with-devdir="/dev" \
	--with-x \
	--with-syslog="LOG_USER" \
	--with-gnu-ld
%{__make} %{?_smp_mflags}

%{__install} -d -m0755 %{name}-smp/
%{__mv} -f %{modules_orig} %{name}-smp/

%install
%{__rm} -rf %{buildroot}
echo -e "\nDriver version: %{version}\nKernel version: %{kversion}-%{krelease}\n"

%makeinstall
%{__install} -d -m0755 %{buildroot}%{_initrddir} \
			%{buildroot}/dev
%{__install} -m0755 lircd.sysv %{buildroot}%{_initrddir}/lircd
%{__install} -m0755 lircmd.sysv %{buildroot}%{_initrddir}/lircmd
%{__install} -m0644 remotes/hauppauge/lircd.conf.hauppauge %{buildroot}%{_sysconfdir}/lircd.conf
%{__install} -m0644 remotes/hauppauge/lircmd.conf.hauppauge %{buildroot}%{_sysconfdir}/lircmd.conf

touch %{buildroot}/dev/lirc{,d,m}

### Install UP module.
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/%{kversion}-%{krelease}%{moduledir}
cd %{name}-up/
%{__install} -m0644 %{modules} %{buildroot}%{_libexecdir}/%{kversion}-%{krelease}%{moduledir}
cd -

### Install SMP module.
%{__install} -d -m0755 %{buildroot}%{_libexecdir}/%{kversion}-%{krelease}smp%{moduledir}
cd %{name}-smp/
%{__install} -m0644 %{modules} %{buildroot}%{_libexecdir}/%{kversion}-%{krelease}smp%{moduledir}
cd -

### Clean up buildroot
%{__rm} -f %{buildroot}%{_libdir}/*.la

%post
/sbin/chkconfig --add lircd
/sbin/chkconfig --add lircmd
[ ! -e /dev/lirc ] && mknod -m0644 /dev/lirc c 61 0 || :
[ ! -e /dev/lircd ] && mknod -m0644 /dev/lircd p || :
[ ! -e /dev/lircm ] && mknod -m0644 /dev/lircm p || :

%preun
if [ $1 -eq 0 ]; then
	/sbin/service lircd stop &>/dev/null || :
	/sbin/service lircmd stop &>/dev/null || :
	/sbin/chkconfig --del lircd
	/sbin/chkconfig --del lircmd
fi

%postun
if [ $1 -ne 0 ]; then
	/sbin/service lircd condrestart &>/dev/null || :
	/sbin/service lircmd condrestart &>/dev/null || :
fi

%postun -n kernel-module-lirc -p "/sbin/depmod -ae"
%postun -n kernel-smp-module-lirc -p "/sbin/depmod -ae"
%post -n kernel-module-lirc -p "/sbin/depmod -ae"
%post -n kernel-smp-module-lirc -p "/sbin/depmod -ae"

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc ANNOUNCE AUTHORS COPYING ChangeLog INSTALL NEWS README TODO
%doc contrib/irman2lirc contrib/lirc*.conf contrib/lircs remotes/
%doc %{_mandir}/man?/*
%config(noreplace) %{_sysconfdir}/lircd.conf
%config(noreplace) %{_sysconfdir}/lircmd.conf
%config %{_initrddir}/*
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/*.so.*
%defattr(0660, root, sys, 0755)
%ghost /dev/lirc
%ghost /dev/lircd
%ghost /dev/lircm

%files devel
%defattr(-, root, root, 0755)
%{_libdir}/*.a
%{_libdir}/*.so
%{_includedir}/lirc/
#exclude %{_libdir}/*.la

%files -n kernel-module-lirc
%defattr(-, root, root, 0755)
%{_libexecdir}/%{kversion}-%{krelease}%{moduledir}/

%files -n kernel-smp-module-lirc
%defattr(-, root, root, 0755)
%{_libexecdir}/%{kversion}-%{krelease}smp%{moduledir}/

%changelog
* Thu Aug 21 2003 Dag Wieers <dag@wieers.com> - 0.6.6-4
- Fixed the SMP builds. (Piotr Stodolny)

* Mon Jul 14 2003 Dag Wieers <dag@wieers.com> - 0.6.6-3
- Updated to kernel release 2.4.20-18.

* Mon Apr 14 2003 Dag Wieers <dag@wieers.com> - 0.6.6-3
- Updated to kernel release 2.4.20-9.

* Wed Apr 09 2003 Dag Wieers <dag@wieers.com> - 0.6.6-2
- Updated to kernel release 2.4.20-8.

* Tue Mar 27 2003 Dag Wieers <dag@wieers.com> - 0.6.6-1
- Updated to kernel release 2.4.18-27.

* Sat Jan 04 2003 Dag Wieers <dag@wieers.com> - 0.6.6-0
- Updated to release 0.6.6 and kernel release 2.4.18-19.

* Sun Jun 30 2002 Dag Wieers <dag@wieers.com> - 0.6.5-0
- Updated to release 0.6.5 and kernel release 2.4.18-5.

* Fri Aug 31 2001 Dag Wieers <dag@wieers.com>
- Initial release.
